define("epi-cms/store/currentContentContext", [
    "dojo/Deferred",
    "dojo/when",
    "epi/shell/_ContextMixin"
], function (Deferred, when, _ContextMixin) {

    return {
        // summary:
        //      Request mutator for adding the currently selected content id to the an xhr request
        // description:
        //      Sets the X-EPiCurrentContentContext header with the currently selected content id
        // tags:
        //      internal

        beforeSend: function (params) {
            // summary:
            //      Adds X-EPiCurrentContentContext to the options.headers of the request parameters.
            // params: Object
            //      The request parameters
            // tags: public

            var options = params.options;
            if (options.isProfileRequest) {
                return when(params);
            }

            var context = new _ContextMixin();
            var result = new Deferred();

            if (context._currentContext && context._currentContext.type === "epi.cms.contentdata" && context._currentContext.id) {
                options.headers["X-EPiCurrentContentContext"] = context._currentContext.id;
            }

            result.resolve(params);

            return result.promise;
        }
    };
});
