define("epi-cms/widget/overlay/LinkItem", [
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi-cms/contentediting/viewmodel/LinkItemModel",
    "epi-cms/widget/overlay/Property"
], function (
// Dojo
    declare,
    lang,
    LinkItemModel,
    Property
) {
    return declare([Property], {
        // summary:
        //      The new overlay item for property LinkItem.
        // description:
        //      Drag and drop page/media to create new link
        // tags:
        //      internal

        modelType: "epi-cms/contentediting/viewmodel/LinkItemModel",

        // model: [public] Object
        //      Instance of modelClass
        model: null,

        onDrop: function (target, value) {
            // summary:
            //      Handles onDrop and add new value to model then raise onValueChange event to save this.
            // target: [Object]
            //      The dnd target.
            // value: [Object || Array]
            //      The dnd data.
            // tags:
            //      protected

            // clear values
            this.model = this._createItemFromDropData(value);
            //this.model._data.length = 0;
            //this.emit("changed");
            arguments[1] = this.model;
            this.inherited(arguments);
        },

        _createItemFromDropData: function (value) {
            var id = { id: new Date().getTime().toString() };
            var linkItem = new LinkItemModel(lang.mixin(lang.clone(value), id));
            return linkItem.serialize();
        }
    });
});
